<?php


class form
{

    public $name;
    public $surname;
    public $address;
    public $code;
    public $city;
    public $pesel;
    public $email;
    public $phone;

    public function __construct($name, $surname, $address, $code, $city, $pesel, $email, $phone) {
        $this->name = $name;
        $this->surname = $surname;
        $this->address = $address;
        $this->code = $code;
        $this->city = $city;
        $this->pesel = $pesel;
        $this->email = $email;
        $this->phone = $phone;
    }

    public function validate() {
        $result = "";
        $validate = false;
        if (!$this->validatePesel())
            $result.="Błędny numer PESEL. Wprowadź poprawny, 11-cyfrowy numer PESEL<br>";
        if (!$this->validateEmail())
            $result.="Niepoprawny adres e-mail. Wprowadź adres w postaci uzytkownik@domena.kraj<br>";
        if (!$this->validatePhone())
            $result.="Niewłaściwy numer telefonu. Powinien składać się on z 9 cyfr, bez żadnych innych znaków<br>";
        if (!$this->validatePostCode())
            $result.="Niepoprawny kod pocztowy. Podaj kod w postaci XX-XXX<br>";
        if ($result == "") {

            $validate = true;
            $result.="Walidacja przebiegła pomyślnie.";
            $this->sendResult($validate, $result);
            return true;
        }
        else {
            $this->sendResult($validate, $result);
            return false;
        }
    }

    public function sendResult($validate, $result) {
        $resultArray = array("validate" => $validate, "result" => $result);
        $jsonResult = json_encode($resultArray);
        echo $jsonResult;
    }

    public function validatePesel() {
        if (!preg_match('/^[0-9]{11}$/', $this->pesel)) { //sprawdzamy czy ciąg ma 11 cyfr
            return false;
        }

        $arrSteps = array(1, 3, 7, 9, 1, 3, 7, 9, 1, 3); // tablica z odpowiednimi wagami
        $intSum = 0;
        for ($i = 0; $i < 10; $i++) {
            $intSum += $arrSteps[$i] * $this->pesel[$i]; //mnożymy każdy ze znaków przez wagć i sumujemy wszystko
        }
        $int = 10 - $intSum % 10; //obliczamy sumć kontrolną
        $intControlNr = ($int == 10) ? 0 : $int;
        if ($intControlNr == $this->pesel[10]) { //sprawdzamy czy taka sama suma kontrolna jest w ciągu
            return true;
        }
        return false;
    }

    public function validateEmail() {
        if (!filter_var($this->email, FILTER_VALIDATE_EMAIL))
            return false;
        else
            return true;
    }

    public function validatePhone() {
        if (strlen($this->phone) == 9 && is_numeric($this->phone))
            return true;
        else
            return false;
    }

    public function validatePostCode() {
        if (preg_match("/^([0-9]{2})(-[0-9]{3})?$/i", $this->code))
            return true;
        else
            return false;
    }

}
foreach ($_POST as $key => $value) {
    $_POST[$key] = htmlspecialchars($value);
}
$form = new form($_POST['name'], $_POST['surname'], $_POST['address'], $_POST['code'], $_POST['city'], $_POST['pesel'], $_POST['email'], $_POST['phone']);
$isValid = $form->validate();


?>
